/*  Regenerate addrecord.html via cgi on the fly for resubmission.
    It tries to keep current records for most of the fields.


Debug compile:
   cc -Wall -o redo_form -DMAINDEF redo_form.c
   redo_form >junk.html

To make start up form (non-CGI):
   cc -Wall -o redo_form -DSTARTUPFORM redo_form.c
   redo_form >addrecord.html


*/

#include <stdio.h>
#include <string.h>
#include "config.h"

void redo_form(char *message, char *user, char *content, char *filename)
{
int ch;
char *pptr;
char categoryfile[1024];
FILE *fp;

printf("\
<HTML><HEAD>\n\
<TITLE>Add Record to Database</TITLE>\n\
</HEAD><BODY>\n\n\
<H2>Add Record to Database</H2>\n\n");


printf("<FORM METHOD=\"GET\" ACTION=\"%s%s\">\n", BASE_URL, SELF_URL);
printf("Press this button to: <INPUT TYPE=\"submit\" VALUE=\"Get a Clean Form\">.\n");
printf("</FORM>\n\n");

/* Error message */
if(message)
    printf("<h3><b>%s</b></h3><br>\n", message);


/* Real form starts here */

printf("<FORM METHOD=\"POST\" ACTION=\"%s%s\">\n\n", BASE_URL, SELF_URL);

printf("\
<b>Record to add</b> to the database (like a Rolodex card):<br>\n\
Include search <b>key words</b> in this text.\n\
Filename below will not be used for search.<br>\n\
Use <b>&lt;title&gt;</b> A title ... <b>&lt;/title&gt;</b> to specify a line\n\
to be displayed in search results.<br>\n\
Otherwise, the filename is displayed.<br>\n\
<TEXTAREA NAME=\"RecordToAdd\" ROWS=15 COLS=65>\n");

    if(content) {
	    pptr = content;
	    while((ch = *pptr++) != '\0'){
		if(ch == '<')
		    printf("&lt;");		/* escape things for HTML */
		else if(ch == '>')
		    printf("&gt;");
		else putchar(ch);
	    }
    }
    else
        printf("&lt;title&gt;&lt;/title&gt;\n\n");

printf("</TEXTAREA>\n<p>\n\n");

printf("\
<b>Filename</b> (Spaces OK.  An extension will be appended automatically.<br>\n\
Descriptive name will be helpful for picking out a record from search results.):<br>\n");

    if(filename)
	printf("<INPUT NAME=\"filename\" value=\"%s\" size=60>\n<br>\n\n", filename);
    else
	printf("<INPUT NAME=\"filename\" size=60>\n<br>\n\n");


printf("<!---- Option words must exactly match the existing directory struct. ---->\n\n");

printf("\
Category: <select name=\"category\">\n");

/* Read out the category list file from BASE_DIR and send it out. */
    strcpy(categoryfile, BASE_DIR);
    strcat(categoryfile, CATEGORY_LIST);
    if((fp = fopen(categoryfile, "r")) != NULL) {
	while((ch = fgetc(fp)) != EOF)
	    putchar(ch);			/* just copy file to stdout */
	fclose(fp);
    } else {					/* provide some minimal list */
printf("<option selected> Incoming\n\
<option> Rolodex/People\n\
<option> Rolodex/Other\n\
<option> References/People\n\
<option> References/Subject\n");
    }

printf("</select>\n\n\n");
/* Category path selector done */

    if(user)
        printf("   Your name: <INPUT NAME=\"user\" value=\"%s\" size=20>\n<br>\n\n", user);
    else
        printf("   Your name: <INPUT NAME=\"user\" size=20>\n<br>\n\n");

printf("\
Press this button to: <INPUT TYPE=\"submit\" VALUE=\"Add Record\">.\n\
<br>\n\n");
printf("</FORM>\n\n");


printf("<a href=\"%s%s\">\n\
<img src=\"%s/images/arrow.gif\" WIDTH=22 HEIGHT=20 align=\"left\">\n\
<b>Return to Search</b></a>\n\
<br>\n\
<p>\n</BODY>\n\
</HTML>\n\n", BASE_URL, SEARCHFORM_URL, BASE_URL);

fflush(stdout);

}


#ifdef MAINDEF

void main(int argc, char *argv[])
{
   redo_form("INCOMPLETE FORM: Please completely fill out all fields !!",
	NULL, "This is a test\nThis is a test2.\n", "A test of form generation");
}

#endif

#ifdef STARTUPFORM

void main(int argc, char *argv[])
{
   redo_form(NULL, NULL, NULL, NULL);
}

#endif


